# Recursion example from Craig'n'Dave

def output():
    # Output the pixel to the screen
    for y in range(0, height):
        for x in range(0, width):
            print(pixel[x][y], end='')
        print()
    print()
    print("---------------------")
    print()


def floodfill(x, y):
    # Continue until the edges are reached
    if x < width and y < height:
        # Fill the cell if it is the wrong colour
        if pixel[x][y] == old_colour:
            pixel[x][y] = new_colour
            # Output the image to observe the recursive steps
            output()
            floodfill(x+1, y)  # Go right
            floodfill(x-1, y)  # Go left
            floodfill(x, y+1)  # Go down
            floodfill(x, y-1)  # Go up


# Main program starts here
width = 4
height = 4
old_colour = 0
new_colour = 1
pixel = [[0 for Y in range(height)] for X in range(width)]
# Run the floodfill starting at position 1,2
floodfill(1, 2)
